This is Fiji
============

[ Fiji Is Just ImageJ ]

Fiji provides an easy way to set up Java, ImageJ and a lot of plugins
that are useful to biologists, geologists and every other scientist who
wants to process images.

At the moment, the following platforms are supported:

- Windows Intel 32-bit
- Windows Intel 64-bit
- Linux Intel 32-bit
- Linux Intel 64-bit
- MacOSX PowerPC 32-bit
- MacOSX Intel 32-bit
- MacOSX Intel 64-bit
- all platforms supporting Java and a POSIX shell, via bin/ImageJ.sh

The setup should be as easy as unpacking the (portable) application and
starting the Java wrapper. The wrapper is a program that starts the Java
machine hands-free, i.e. it sets the correct settings to start up ImageJ
with the plugins directory and heap size set up for you.

Fiji is intended to be the most painless, easy, quick and convenient way
to install ImageJ and plugins and keep everything up-to-date.


Usage
-----

Fiji is meant to be distributed without source, to make the download as
small as possible. In the basic version, Fiji is a portable application,
i.e. it should run wherever you copy it.

The starting point is the ImageJ launcher, which will launch Java, set
up the environment, and call ImageJ.

To pass arguments to ImageJ, just specify them on the command line.

To pass arguments to the Java Virtual Machine, specify them on the
command line, separating them from the ImageJ arguments (if any) with a
`--`.  In other words, if you want to override the memory setting, call
Fiji like this:

	$ ./ImageJ-linux32 -Xmx128m --

Open Source
-----------

We are dedicated to open source. Not only does open source allow other
developers to port the application to new platforms that the original
authors did not begin to think of, it permits others to use the program
in totally new ways, and enhance it in all imaginable ways.

Therefore, Fiji is licensed under the GNU Public License, version 2 (of
course, this license only applies to Fiji: the build system and the Java
wrapper). Not version 3, because we think that it is not our job to
educate everybody to be a decent person; that's every person's own job.

In the same vein, Fiji will contain only Open Source software, unless
there are good reasons for a non-open sourced component to be included.

But those would need to be _very_ compelling reasons.

Participating
-------------

Pull Requests are very welcome!

Authors
-------

* Albert Cardona
* Benjamin Schmid
* Cornelius Sicker
* Curtis Rueden
* Dan White
* Daniel Hornung
* Erwin Frise
* Gabriel Landini
* Greg Jefferis
* Ignacio Arganda-Carreras
* Jan Eglinger
* Jean-Yves Tinevez
* Johannes Schindelin
* Jolly Jenkins
* Kota Miura
* Larry Lindsey
* Mark Longair
* Niko Ehrenfeuchter
* Pavel Tomancak
* Stephan Preibisch
* Stephan Saalfeld
* Tiago Ferreira
* Tom Kazimiers
* Verena Kaynig
* Wayne Rasband
* and all the good people providing ImageJ and plugins

See also http://fiji.sc/Contributors

Thanks
------

Our first and foremost thanks go to Wayne Rasband, who is not only a
very dedicated developer; he also fosters an active and friendly
community around ImageJ.

The rest of our thanks go to everybody who helped this project prosper.

Oh, and Fiji is also an island. We just wanted to let you know.
